#include <iostream.h>

//----------code added for S2ACOM by chming ----
#include "S2ACOM.h"		// this is a server file
#include <Comdef.h>		// for usage of BSTR
#include <Atlbase.h>	// for usage of CComBSTR

void main(int argc, char *argv[])
{
	// TODO: Add extra validation here
    char *ServerIP="203.66.172.131"; //Socket to air server ip
    char *ServerPort="8000";         //Socket to air server port
    char Account[10];				 //b
    char Passwd[10];				 //KX
    char Msisdn[12];				 //X
    char Message[160];				 //²Te
	int  ret=-99;					 //init value
	
	if(argc<5){
		printf("\nUsage : vc6_console <Login> <Pw> <TelNum> <Msg> ");
		printf("\n <ex> : vc6_console test test1 0932xxxxxx message");
		exit(0);
	}

    //oѼƭ
	strcpy(Account, argv[1]);
	strcpy(Passwd, argv[2]);
	strcpy(Msisdn, argv[3]);
	strcpy(Message, argv[4]);

	//Nchar* নBSTR
	BSTR bServerIP	 = _com_util::ConvertStringToBSTR(ServerIP);
	BSTR bServerPort = _com_util::ConvertStringToBSTR(ServerPort);
	BSTR bAccount	 = _com_util::ConvertStringToBSTR(Account);
	BSTR bPasswd	 = _com_util::ConvertStringToBSTR(Passwd);
	BSTR bMsisdn	 = _com_util::ConvertStringToBSTR(Msisdn);
	BSTR bMessage	 = _com_util::ConvertStringToBSTR(Message);

    //Get the below two constants from the S2ACOM_i.c
    const IID IID_IS2Air = {0x4F91871D,0x9B96,0x45C2,{0xB6,0x70,0x2D,0x5D,0x9C,0xE5,0xFF,0x44}};
    const CLSID CLSID_S2Air = {0x31C80217,0x22B5,0x4BA9,{0x8A,0x3C,0x0B,0x4F,0xC2,0x4A,0x44,0x1F}};

	HRESULT hr = CoInitialize(NULL); // Initialize COM library
    CComBSTR mresult;

    if (SUCCEEDED(hr)){ //To check if CoInitialize success or not
		IS2Air *pIS2Air = NULL;
		hr = CoCreateInstance(CLSID_S2Air, NULL,
			CLSCTX_INPROC_SERVER, IID_IS2Air, (void**)&pIS2Air);
		if (SUCCEEDED(hr)){
			//إ߻PSocket to airsu
			pIS2Air->StartCon(bServerIP,bServerPort,bAccount,bPasswd,&ret);
			if(ret==0){ //إ߳su\
				//}lǰer²TApnǰeh²TAuݦbhIsSendMsg()Yi
				pIS2Air->SendMsg(bMsisdn,bMessage,&ret,&mresult);
				_bstr_t res = mresult; //CComBSTR to BSTR
                char *ret_description = res; //BSTR to char*
				cout << "ǰe,ret_code=" << ret << " ret_description=" 
					 << ret_description << endl;
			}else{
				cout << "إ߳su,ret_code=" << ret << endl;
			}
			pIS2Air->EndCon();  //su
			pIS2Air->Release();
		}else{
			cout << "CreateInstance Fail!" << endl;
		}
		CoUninitialize();
	}else{
		cout << "Failed to initialize S2ACOM library" << endl;
	}

	//release BSTR
    ::SysFreeString(bServerIP);
    ::SysFreeString(bServerPort);
    ::SysFreeString(bAccount);
    ::SysFreeString(bPasswd);
    ::SysFreeString(bMsisdn);
    ::SysFreeString(bMessage);	

}